// Generated by CoffeeScript 1.7.1
var fs, parser, pg, pgJSON, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

_ = require('lodash');

pg = require('pg');

fs = require('fs');

parser = require('../lib/parse');

pgJSON = (function() {
  function pgJSON(dbUrl) {
    this.removeIndex = __bind(this.removeIndex, this);
    this.reIndexCollection = __bind(this.reIndexCollection, this);
    this.reIndex = __bind(this.reIndex, this);
    this.createTSIndex = __bind(this.createTSIndex, this);
    this.createIndex = __bind(this.createIndex, this);
    this.countByQuery = __bind(this.countByQuery, this);
    this.removeByQuery = __bind(this.removeByQuery, this);
    this.query = __bind(this.query, this);
    this.mkSQLCommand = __bind(this.mkSQLCommand, this);
    this.queryById = __bind(this.queryById, this);
    this.removeById = __bind(this.removeById, this);
    this.findOneAndPopulate = __bind(this.findOneAndPopulate, this);
    this.findOneAndUpdateArray = __bind(this.findOneAndUpdateArray, this);
    this.upsert = __bind(this.upsert, this);
    this.findOneAndUpdate = __bind(this.findOneAndUpdate, this);
    this.update = __bind(this.update, this);
    this.insert = __bind(this.insert, this);
    this.isCollectionExist = __bind(this.isCollectionExist, this);
    this.clearCollection = __bind(this.clearCollection, this);
    this.removeCollection = __bind(this.removeCollection, this);
    this.addCollection = __bind(this.addCollection, this);
    this.loadSqlFile = __bind(this.loadSqlFile, this);
    this.pgQuery = __bind(this.pgQuery, this);
    this.getCollectionName = __bind(this.getCollectionName, this);
    this.setDbUrl2 = __bind(this.setDbUrl2, this);
    this.setDbUrl = __bind(this.setDbUrl, this);
    this.dbUrl = dbUrl;
    this.preparedQuery = {};
    this.schemaName = "node_pg_json";
    this.loadSqlFile(__dirname + "/postgresJSON.sql", (function(_this) {
      return function(error) {
        if (error) {
          return console.log("pg_json warning: failed to load postgresJSON.sql." + error + "\r\n");
        }
      };
    })(this));
  }

  pgJSON.prototype.setDbUrl = function(dbUrl) {
    return this.dbUrl = dbUrl;
  };

  pgJSON.prototype.setDbUrl2 = function(postgres) {
    return this.dbUrl = "postgres://" + postgres.username + ":" + postgres.password + "@" + postgres.hostname + ":" + postgres.port + "/" + postgres.db;
  };

  pgJSON.prototype.getCollectionName = function(name) {
    return "" + this.schemaName + "." + name;
  };

  pgJSON.prototype.pgQuery = function(queryString, paraArray, callback) {
    return pg.connect(this.dbUrl, (function(_this) {
      return function(error, client, release) {
        if (error) {
          return callback(error);
        }
        return client.query(queryString, paraArray, function(err, data) {
          release();
          return callback(err, data);
        });
      };
    })(this));
  };

  pgJSON.prototype.loadSqlFile = function(sglFile, callback) {
    return fs.readFile(sglFile, (function(_this) {
      return function(error, data) {
        var sql;
        if (error) {
          return callback(error);
        }
        sql = data.toString();
        return _this.pgQuery(sql, null, callback);
      };
    })(this));
  };

  pgJSON.prototype.addCollection = function(collection, callback) {
    return this.pgQuery("CREATE SCHEMA if not exists " + this.schemaName + ";", null, (function(_this) {
      return function(error) {
        if (error) {
          return callback(error);
        }
        return _this.pgQuery("CREATE TABLE if not exists " + _this.schemaName + "." + collection + " (_id UUID PRIMARY KEY, data JSONB NOT NULL);", null, callback);
      };
    })(this));
  };

  pgJSON.prototype.removeCollection = function(collection, callback) {
    return this.pgQuery("DROP TABLE IF EXISTS " + this.schemaName + "." + collection + " CASCADE;", null, callback);
  };

  pgJSON.prototype.clearCollection = function(collection, callback) {
    return this.pgQuery("DELETE FROM " + this.schemaName + "." + collection + ";", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount);
      };
    })(this));
  };

  pgJSON.prototype.isCollectionExist = function(collection, callback) {
    return this.pgQuery("SELECT EXISTS (SELECT 1 FROM pg_catalog.pg_class c JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace WHERE  n.nspname = $1::text AND c.relname = $2::text);", [this.schemaName, collection], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rows[0].exists);
      };
    })(this));
  };

  pgJSON.prototype.insert = function(docId, collection, doc, callback) {
    return this.pgQuery("SELECT insert_row as data from insert_row($1::regclass, $2::uuid, $3::jsonb);", ["" + this.schemaName + "." + collection, docId, doc], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount === 1 ? result.rows[0].data : void 0);
      };
    })(this));
  };

  pgJSON.prototype.update = function(docId, collection, doc, callback) {
    return this.pgQuery("SELECT update_row as updated from update_row($1::regclass, $2::uuid, $3::jsonb);", ["" + this.schemaName + "." + collection, docId, doc], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rows[0].updated);
      };
    })(this));
  };

  pgJSON.prototype.findOneAndUpdate = function(docId, collection, toMerge, callback) {
    return this.pgQuery("UPDATE " + this.schemaName + "." + collection + " SET data = json_merge_obj(data::json, $2::json)::jsonb WHERE _id = $1::uuid RETURNING data;", [docId, toMerge], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount === 1 ? result.rows[0].data : void 0);
      };
    })(this));
  };

  pgJSON.prototype.upsert = function(docId, collection, doc, callback) {
    return this.pgQuery("SELECT upsert_row as upserted from upsert_row($1::regclass, $2::uuid, $3::jsonb);", ["" + this.schemaName + "." + collection, docId, doc], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rows[0].upserted);
      };
    })(this));
  };

  pgJSON.prototype.findOneAndUpdateArray = function(docId, collection, parameter, callback) {
    return this.pgQuery("UPDATE " + this.schemaName + "." + collection + " SET data = json_update_array_property(data::json, $2::json)::jsonb WHERE _id = $1::uuid RETURNING data;", [docId, parameter], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount === 1 ? result.rows[0].data : void 0);
      };
    })(this));
  };

  pgJSON.prototype.findOneAndPopulate = function(docId, collection, populate, callback) {
    var error;
    try {
      populate.from_table = "" + this.schemaName + "." + populate.from;
    } catch (_error) {
      error = _error;
      return callback("findOneAndPopulate: " + error + "\r\n");
    }
    return this.pgQuery("SELECT query_by_id_and_populate($1::text, $2::uuid, $3::json) as data;", ["" + this.schemaName + "." + collection, docId, populate], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rows[0].data);
      };
    })(this));
  };

  pgJSON.prototype.removeById = function(docId, collection, callback) {
    return this.pgQuery("DELETE FROM " + this.schemaName + "." + collection + " WHERE _id = $1::UUID;", [docId], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount);
      };
    })(this));
  };

  pgJSON.prototype.queryById = function(docId, collection, select, callback) {
    var error, selectAll, selectField;
    try {
      selectField = parser.parseSelect(select);
    } catch (_error) {
      error = _error;
      return callback(("queryById: " + select) + error + "\r\n");
    }
    selectAll = selectField === "*";
    if (selectAll) {
      selectField = "to_json(data) as data";
    }
    return this.pgQuery("SELECT " + selectField + " FROM select_by_id($1::text, $2::uuid);", ["" + this.schemaName + "." + collection, docId], (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        if (result.rows.length === 1) {
          if (selectAll) {
            return callback(null, result.rows[0].data);
          } else {
            return callback(null, result.rows[0]);
          }
        } else {
          return callback(null, null);
        }
      };
    })(this));
  };

  pgJSON.prototype.mkSQLCommand = function(collection, select, where, orderBy, limit, offset) {
    var cmd;
    cmd = "SELECT " + select + " FROM " + this.schemaName + "." + collection;
    if (where != null) {
      cmd += "  WHERE " + where;
    }
    if (orderBy != null) {
      cmd += " ORDER BY " + orderBy;
    }
    if (limit != null) {
      cmd += " LIMIT " + limit;
    }
    if (offset != null) {
      cmd += " OFFSET " + offset;
    }
    cmd += ";";
    return cmd;
  };

  pgJSON.prototype.query = function(collection, condition, callback) {
    var error, limit, offset, orderBy, select, selectAll, where;
    try {
      select = parser.parseSelect(condition.select);
      where = parser.parseWhere(condition.where);
      orderBy = parser.parseOrderBy(condition.orderBy);
      limit = parser.parseLimit(condition.limit);
      offset = parser.parseOffset(condition.offset);
    } catch (_error) {
      error = _error;
      return callback(("query: " + condition + " ") + error + "\r\n");
    }
    selectAll = select === "*";
    if (selectAll) {
      select = "to_json(data) as data";
    }
    return this.pgQuery(this.mkSQLCommand(collection, select, where, orderBy, limit, offset), null, (function(_this) {
      return function(error, result) {
        var refactoredResult;
        if (error) {
          return callback(error);
        }
        if (result.rows.length >= 1) {
          if (selectAll) {
            refactoredResult = [];
            _.forEach(result.rows, function(r) {
              return refactoredResult.push(r.data);
            });
            return callback(null, refactoredResult);
          } else {
            return callback(null, result.rows);
          }
        } else {
          return callback(null, []);
        }
      };
    })(this));
  };

  pgJSON.prototype.removeByQuery = function(collection, condition, callback) {
    var error, where;
    try {
      where = parser.parseWhere(condition.where);
    } catch (_error) {
      error = _error;
      return callback(("removeByQuery: " + condition) + error + "\r\n");
    }
    return this.pgQuery("DELETE FROM " + this.schemaName + "." + collection + " WHERE " + where + ";", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, result.rowCount);
      };
    })(this));
  };

  pgJSON.prototype.countByQuery = function(collection, condition, callback) {
    var error, where;
    try {
      where = parser.parseWhere(condition.where);
    } catch (_error) {
      error = _error;
      return callback(("countByQuery: " + condition) + error + "\r\n");
    }
    return this.pgQuery("SELECT count(*) FROM " + this.schemaName + "." + collection + " WHERE " + where + ";", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        if (result.rowCount === 1) {
          return callback(null, JSON.parse(result.rows[0].count));
        } else {
          return callback("unexpected count result: " + result);
        }
      };
    })(this));
  };

  pgJSON.prototype.createIndex = function(collection, field, asText, callback) {
    var error, index, indexName;
    try {
      index = parser.parseIndexField(field, asText);
    } catch (_error) {
      error = _error;
      return callback(("createIndex: " + field) + error + "\r\n");
    }
    field = field.replace(/:/g, ".");
    indexName = "\"" + this.schemaName + "." + collection + "." + field + "\"";
    return this.pgQuery("CREATE INDEX " + indexName + " ON " + this.schemaName + "." + collection + " ((" + index + "));", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, null);
      };
    })(this));
  };

  pgJSON.prototype.createTSIndex = function(collection, field, language, callback) {
    var error, index, indexName;
    if (language == null) {
      language = "simple";
    }
    try {
      index = parser.parseTSIndex(field, language);
    } catch (_error) {
      error = _error;
      return callback(("createTSIndex: " + field + ", " + language) + error + "\r\n");
    }
    indexName = "\"" + this.schemaName + "." + collection + "." + field + "\"";
    return this.pgQuery("CREATE INDEX " + indexName + " ON " + this.schemaName + "." + collection + " USING gin(to_tsvector(\'" + language + "\', " + index + "));", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, null);
      };
    })(this));
  };

  pgJSON.prototype.reIndex = function(collection, field, asText) {
    var error, index, indexName;
    try {
      index = parser.parseIndexField(field, asText);
    } catch (_error) {
      error = _error;
      return callback(("createIndex: " + field) + error + "\r\n");
    }
    field = field.replace(/:/g, ".");
    indexName = "\"" + this.schemaName + "." + collection + "." + field + "\"";
    return this.pgQuery("REINDEX INDEX " + indexName, null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, null);
      };
    })(this));
  };

  pgJSON.prototype.reIndexCollection = function(collection, callback) {
    return this.pgQuery("REINDEX TABLE " + this.schemaName + "." + collection, null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, null);
      };
    })(this));
  };

  pgJSON.prototype.removeIndex = function(collection, field, asText) {
    var error, index, indexName;
    try {
      index = parser.parseIndexField(field, asText);
    } catch (_error) {
      error = _error;
      return callback(("createIndex: " + field) + error + "\r\n");
    }
    field = field.replace(/:/g, ".");
    indexName = "\"" + this.schemaName + "." + collection + "." + field + "\"";
    return this.pgQuery("DROP INDEX " + indexName + " IF EXISTS CASCADE", null, (function(_this) {
      return function(error, result) {
        if (error) {
          return callback(error);
        }
        return callback(null, null);
      };
    })(this));
  };

  return pgJSON;

})();

module.exports = new pgJSON();
